<?php

/**
*
* Plugin Name: BPI Fancy Reviews
* Plugin URI: https://www.businesspromotion.com/
*
* Description: A Fancy way to add reviews to your site.
* Author: Jeremy Winegar
* Author URI: https://www.businesspromotion.com/
* Version: 0.040
* License: GPLv2
*
**/

// if this file is called directly then abort

if ( ! defined( 'WPINC' ) ) {
	die;
}

require 'plugin-update-checker/plugin-update-checker.php';
$MyUpdateChecker = PucFactory::buildUpdateChecker(
    'https://util.businesspromotion.com/plugin_auto_update/bp_fancy_reviews_Meta_Data.php',
    __FILE__,
    'bp_fancy_reviews'
);
if (isset($_GET['check_for_bp_fancy_reviews_update']))
{
	$MyUpdateChecker->checkForUpdates();
}

/* we need to setup all the dependencies */ 
require_once( 'scripts/libraries/bp-reviews-generator.class.php' );

/* we want to setup our activate and deactive hooks */ 
function activateBPFancyReviewsGenerator() 
{ 
	BPFancyReviewGenerator::activate(); 
} 

function deactivateBPFancyReviewsGenerator() 
{ 
	BPFancyReviewGenerator::deactivate(); 
}

register_activation_hook(__FILE__, 'activateBPFancyReviewsGenerator'); 
register_deactivation_hook(__FILE__, 'deactivateBPFancyReviewsGenerator');

function setupBpFancyReviewsGenerator()
{
	/* create new coupon generator, and setup the object */
	$plugin = new BPFancyReviewGenerator();
	$plugin->setup();
}

setupBpFancyReviewsGenerator();

function getReviews()
{
	ob_start();
	include 'scripts/layout/reviews-page.php';
	$ob = ob_get_contents();
	ob_end_clean();
	return $ob;
}

add_shortcode( 'fancy-reviews', 'getReviews' );