"use strict";

var editReviewsMain =
{
	setup: function()
	{
		this.removeReview();
		this.editReview();
	},
	
	confirmMessage: function( msg )
	{
		return "Are you sure that you want to " + msg + " this review?";
	},
	
	removeReview: function()
	{
		var self = this,
			$ = jQuery;
		
		$( '.removeMe' ).on( 'click', function()
		{
			var msg = self.confirmMessage( 'delete' );
			var confirmDeleteReview = confirm( msg );
			
			if ( confirmDeleteReview === true )
			{
				var data =
				{
					action : 'removeReview',
					id     : $( this ).data( 'remove_number' )
				};
				
				var ajaxurl = '/wp-admin/admin-ajax.php';
				
				$.post( ajaxurl, data, function( response ) {
					$( '#success' ).html( '<div class="saveSuccess">' + response + '</div>' );
				});
			}
			else
			{
				$( '#success' ).html( '<div class="saveFailure">I won\'t do anything yet!</div>' );
//				alert( "I won't do anything yet!" );
			}
		});
	},
	
	editReview: function()
	{
		var $ = jQuery,
			self = this;			
		
		$( '.edit-btn' ).on( 'click', function()
		{
			var reviewNum = $(this).parents( '.review-entry-box' ).children( '.reviewId' ).val(),
				review = 'review_' + reviewNum,
				reviewer = 'reviewer_' + reviewNum,
				stars = 'stars_' + reviewNum,
				select_section = 'select_section_' + reviewNum,
				should_review_form_name = 'should_review_' + reviewNum,
				should_review_form = document.getElementById(should_review_form_name),
				should_review_choice = should_review_form.options[should_review_form.selectedIndex].value,
				msg = self.confirmMessage( 'edit' );
			
			var confirmEdit = confirm( msg );
		
			if ( confirmEdit === true )
			{
				var data =
				{
					action   		: 'editReview',
					id       		: reviewNum,
					review   		: document.getElementById( review ).value,
					reviewer 		: document.getElementById( reviewer ).value,
					stars    		: document.getElementById( stars ).value,
					should_review	: should_review_choice
				};

				var ajaxurl = '/wp-admin/admin-ajax.php';
				
				if (data.should_review === '0')
				{
					document.getElementById(select_section).style.display = 'none';
				}

				$.post( ajaxurl, data, function( response ) {
					$( '#success' ).html( '<div class="saveSuccess">' + response + '</div>' );
					
				});
			}
			else
			{
				$( '#success' ).html( '<div class="saveFailure">I won\'t do anything yet!</div>' );
			}
			
		});

	}
};

jQuery(function(){
	editReviewsMain.setup();
});