var ReviewMain = function(reviewCol1Ele, reviewCol2Ele, reviewCol3Ele, reviewCol4Ele, myModalEle)
{
	this.reviewCol1Ele = reviewCol1Ele;
	this.reviewCol2Ele = reviewCol2Ele;
	this.reviewCol3Ele = reviewCol3Ele;
	this.reviewCol4Ele = reviewCol4Ele;
	this.myModalEle    = myModalEle;
	this.setup();
};

ReviewMain.prototype =
{
	constructor: ReviewMain,
	
	setup: function()
	{
		this.getReviews();
		this.setupModal();
		this.submitModal();
	},
	
	settings : null,
	
	getReviews: function()
	{
		var $ = jQuery,
			data = {action : 'fancyReviewSettings'},
			ajaxurl = '/wp-admin/admin-ajax.php',
			self = this;
		
		$.post(ajaxurl, data, function(response) {
			var answer = JSON.parse(response);
			self.settings = answer;
			
			var secondData = {action : 'getAllReviews'};
			
			$.post(ajaxurl, secondData, function(response) {
				var newAnswer = JSON.parse(response),
					colNum = 0,
					columns = [self.reviewCol1Ele, self.reviewCol2Ele, self.reviewCol3Ele, self.reviewCol4Ele];
				
				for (var i = 0, len = newAnswer.length; i < len; i++)
				{
					colNum = self.setColNum();
					var review = newAnswer[i].review,
						reviewer_name = newAnswer[i].reviewer_name,
						stars = newAnswer[i].stars;
					
					columns[colNum].innerHTML += self.reviewBuilder(review.replace(/\\/g, ''), reviewer_name.replace(/\\/g, ''), stars);
				}
				self.showFirst();
			});
		});
		
	},
	
	reviewBuilder: function(review, reviewer, stars)
	{
		var self = this;
		var putStars = this.makeStars(stars);

		var putDiv = "<div id='review-object' class='bpfr_review-box' style='background-color: " + self.settings[0].backgroundColor + "; border: " + self.settings[0].borderWidth + "px " + self.settings[0].borderColor + " solid; border-radius: " + self.settings[0].borderRadius + "px;' data-animate='" + self.settings[0].animation + "'>";
		
		putDiv += putStars + "<div class='bpfr_review' style='color: " + self.settings[0].reviewColor + "; font-weight: normal; ";
		
		if (self.settings[0].reviewItalics === 'true')
		{
			putDiv += "font-style: italic;";
		}
		else
		{
			putDiv += "font-style: normal;";
		}
		
		putDiv += "'> " + review + "</div><div class='bpfr_reviewer' style='color: " + self.settings[0].reviewerColor + "; font-weight: normal; ";
		
		if (self.settings[0].reviewerItalics === 'true')
		{
			putDiv += "font-style: italic;";
		}
		else
		{
			putDiv += "font-style: normal;";
		}
		
		putDiv += "'>- " + reviewer + "</div></div>";
		
		return putDiv;
	},
	
	setColNum: function()
	{
		var	column1Height = this.reviewCol1Ele.clientHeight,
			column2Height = this.reviewCol2Ele.clientHeight,
			column3Height = this.reviewCol3Ele.clientHeight,
			column4Height = this.reviewCol4Ele.clientHeight,
			columnHeights = [ column1Height, column2Height, column3Height, column4Height ];

		var shortColumn = this.indexOfSmallest(columnHeights);

		return shortColumn;
	},
	
	indexOfSmallest: function(columnHeights)
	{
		var shortestHeight = 0;
		
		for (var i = 0, len = columnHeights.length; i < len; i++)
		{
			if (columnHeights[i] < columnHeights[shortestHeight])
			{
				shortestHeight = i;
			}
		}
		
		return shortestHeight;
	},
	
	makeStars: function(stars)
	{
		var starBox = '<div class="rating-container"><ul class="star-container">';

		for (var i = 5; i > 0; i--)
		{
			if(i === Number(stars))
			{
				starBox += '<li class="star selected"></li>';
			}
			else
			{
				starBox += '<li class="star"></li>';
			}
		}
		starBox += '</ul></div>';

		return starBox;
	},
	
	showFirst: function()
	{
		var $ = jQuery;
		
		$('#col-1 div').first().addClass(this.settings[0].animation).css({"opacity": '1', "margin-top": '0'});
		$('#col-2 div').first().addClass(this.settings[0].animation).css({"opacity": '1', "margin-top": '0'});
		$('#col-3 div').first().addClass(this.settings[0].animation).css({"opacity": '1', "margin-top": '0'});
		$('#col-4 div').first().addClass(this.settings[0].animation).css({"opacity": '1', "margin-top": '0'});
	},
	
	setupModal: function()
	{
		var $ = jQuery,
			firstModal = this.myModalEle;
		
		$('<div class="modal fade fadeIn" id="bpfrModal"></div>').insertAfter(firstModal);
		modalArray.push('bpfrModal');
		
		var modalForm = '';
		modalForm += '<div class="modal-dialog">';
		modalForm += '<div class="modal-content">';
		modalForm += '<div class="modal-header">';
		modalForm += '<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>';
		modalForm += '<h4 class="modal-title">Leave a Review</h4>';
		modalForm += '<hr>';
		modalForm += '</div>';
		modalForm += '<div class="modal-body">';
		modalForm += '<div class="add-review-form" style="width: 500px; margin: 0 auto;">';
		modalForm += '<form action="" method="post" id="add_review_form">';
		modalForm += '<div id="add-review-box">';
		modalForm += '<div class="review-entry-box">';
		modalForm += '<textarea name="review" class="entry-review val" id="review" cols="50" rows="5" placeholder="Insert Review Here:"></textarea>';
		modalForm += '<input type="text" name="reviewer" class="entry-reviewer val" id="reviewer" placeholder="Reviewer Here:">';
		modalForm += '<input type="number" name="stars" class="entry-stars" id="stars" value="5" min="0" max="5"> (Stars)';
		modalForm += '<input type="hidden" name="url" id="url" placeholder="URL">';
		modalForm += '</div></div>';
		modalForm += '<span class="main-fancy-btn left transition" id="modal-save-review-btn">Save Review</span>';
		modalForm += '</form>';
		modalForm += '<div id="modal_success_manual"></div>';
		modalForm += '</div></div></div></div>';
		
		$('#bpfrModal').html(modalForm);
	},
	
	submitModal: function()
	{
		var $ = jQuery,
			saveReview = $('#modal-save-review-btn');
		
		saveReview.on('click', function() {
			if ($('#url').val() === '')
			{
				if ($('#review').val() === '' && $('#reviewer').val() === '')
				{
					$('#modal_success_manual').html('<div class="saveFailure">Please enter a review, and a reviewer</div>');
				}
				else if ($('#review').val() === '')
				{
					$('#modal_success_manual').html('<div class="saveFailure">Please enter a review</div>');
				}
				else if ($('#reviewer').val() === '')
				{
					$('#modal_success_manual').html('<div class="saveFailure">Please enter a reviewer</div>');
				}
				else
				{
					var data = {
						action   		: 'storeReview',
						review   		: $('#review').val(),
						reviewer 		: $('#reviewer').val(),
						stars    		: $('#stars').val(),
						should_review	: 1
					};

					var ajaxurl = '/wp-admin/admin-ajax.php';

					$.post(ajaxurl, data, function(response) {
						$('#modal_success_manual').html('<div class="saveSuccess">' + response + '</div>');
						$('#review').val('');
						$('#reviewer').val('');
						$('#stars').val('5');
					});
				}
			}
			else
			{
				$('#success_manual').html('<div class="saveSuccess">Thank you for your submission</div>');
			}
		});
	}
};

jQuery(function() {
	var doc = document;
	
	var reviewController = new ReviewMain(doc.getElementById( 'col-1' ), doc.getElementById( 'col-2' ), doc.getElementById( 'col-3' ), doc.getElementById( 'col-4' ), doc.getElementById('myModal'));
});