"use strict";

var settingsPageMain =
{
	setup: function()
	{
		this.viewFancyReviewSettings();
		this.setupReviewSettingsForm();
		
	},
	
	setupReviewSettingsForm: function()
	{
		var $ = jQuery;
		
		var data =
		{
			action : 'fancyReviewSettings'
		};
		
		var ajaxurl = '/wp-admin/admin-ajax.php';
		
		$.post(ajaxurl, data, function(response) {
			var answer = JSON.parse(response);
			
			document.getElementById('pickAnimation').value = answer[0].animation;			
			document.getElementById( 'backgroundColor' ).value = answer[0].backgroundColor;			
			document.getElementById( 'borderColor' ).value = answer[0].borderColor;
			document.getElementById( 'borderRadius' ).value = answer[0].borderRadius;			
			document.getElementById( 'borderWidth').value = answer[0].borderWidth;
			document.getElementById( 'reviewColor' ).value = answer[0].reviewColor;		
			document.getElementById( 'reviewerColor' ).value = answer[0].reviewerColor;
			
			if ( answer[0].reviewItalics === 'true' )
			{				
				document.getElementById( 'italReview' ).checked = true;
			}
			if ( answer[0].reviewerItalics === 'true' )
			{			
				document.getElementById('italReviewer').checked = true;
			}
			if ( answer[0].showStars === 'true' )
			{
				document.getElementById( 'showStars' ).checked = true;
				document.getElementById( 'showStarsChecked' ).value = 'yes';				
			}
			else
			{
				document.getElementById( 'showStars' ).checked = false;
				document.getElementById( 'showStarsChecked' ).value = 'no';				
			}
			
		});
	},
	
	viewFancyReviewSettings: function()
	{
		var $ = jQuery,
			success = $('.success'),
			distance = success.offset().top - 100;
		
		$('.preview-box').css('top', distance + 'px').html('<div class="review-box" id="review-box"><div class="rating-container"><ul class="star-container"><li class="star"></li><li class="star selected"></li><li class="star"></li><li class="star"></li><li class="star"></li></ul></div><div class="review">"Bacon ipsum dolor amet meatloaf shank strip steak, andouille biltong capicola spare ribs doner. Bresaola beef ribs pancetta sausage biltong short ribs filet mignon spare ribs turkey pork chop rump boudin bacon."</div><div class="reviewer">- Sam Hammich</div></div>');
		
		var data =
		{
			action : 'fancyReviewSettings'
		};
		
		var ajaxurl = '/wp-admin/admin-ajax.php';
		
		$.post( ajaxurl, data, function( response ) {
			var answer = JSON.parse( response );
			
			document.getElementById('review-box').className += ' ' + answer[0].animation;			
			document.getElementById( 'review-box' ).style.backgroundColor = answer[0].backgroundColor;			
			document.getElementById( 'review-box' ).style.borderColor = answer[0].borderColor;			
			document.getElementById( 'review-box' ).style.borderRadius = answer[0].borderRadius + "px";			
			document.getElementById( 'review-box' ).style.borderWidth = answer[0].borderWidth + "px";
			document.getElementById( 'review-box' ).style.borderStyle = 'solid';			
			document.querySelector( '.review' ).style.color = answer[0].reviewColor;			
			document.querySelector( '.reviewer' ).style.color = answer[0].reviewerColor;
			
			if ( answer[0].reviewItalics === 'true' )
			{
				document.querySelector( '.review' ).style.fontStyle = "italic";
			}
			if ( answer[0].reviewerItalics === 'true' )
			{
				document.querySelector( '.reviewer' ).style.fontStyle = "italic";
			}
			if ( answer[0].showStars === 'true' )
			{				
				document.querySelector( '.rating-container' ).style.display = 'block';
			}
			else
			{				
				document.querySelector( '.rating-container' ).style.display = 'none';
			}
			
		});
	},
	
	previewFancyReviewSettings: function()
	{		
		var $ = jQuery,
			tempSelect = document.getElementById( 'pickAnimation' ),
			tempAnimation = tempSelect.options[tempSelect.selectedIndex].value,
			tempBorderWidth = document.getElementById( 'borderWidth' ).value,
			tempBorderColor = document.getElementById( 'borderColor' ).value,
			tempBorderRadius = document.getElementById( 'borderRadius' ).value,
			tempBackgroundColor = document.getElementById( 'backgroundColor' ).value,
			tempShowStars = document.getElementById( 'showStars' ).checked,
			tempReviewColor = document.getElementById( 'reviewColor' ).value,
			tempReviewItalics = document.getElementById( 'italReview' ).checked,
			tempReviewerColor = document.getElementById( 'reviewerColor' ).value,
			tempReviewerItalics = document.getElementById( 'italReviewer' ).checked;
		
		$( '.review-box' ).remove();
		$( '.preview-box' ).html( '<div class="review-box" id="review-box"><div class="rating-container"><ul class="star-container"><li class="star"></li><li class="star selected"></li><li class="star"></li><li class="star"></li><li class="star"></li></ul></div><div class="review">"Bacon ipsum dolor amet meatloaf shank strip steak, andouille biltong capicola spare ribs doner. Bresaola beef ribs pancetta sausage biltong short ribs filet mignon spare ribs turkey pork chop rump boudin bacon."</div><div class="reviewer">- Sam Hammich</div></div>' );
		
		document.getElementById( 'review-box' ).className += ' ' + tempAnimation;
		document.getElementById( 'review-box' ).style.backgroundColor = tempBackgroundColor;
		document.getElementById( 'review-box' ).style.borderColor = tempBorderColor;
		document.getElementById( 'review-box' ).style.borderRadius = tempBorderRadius + "px";
		document.getElementById( 'review-box' ).style.borderWidth = tempBorderWidth + "px";
		document.getElementById( 'review-box' ).style.borderStyle = 'solid';
		document.querySelector( '.review' ).style.color = tempReviewColor;
		document.querySelector( '.reviewer' ).style.color = tempReviewerColor;
			
		if ( tempReviewItalics === true )
		{
			document.querySelector( '.review' ).style.fontStyle = "italic";
		}
		if ( tempReviewerItalics === true )
		{
			document.querySelector( '.reviewer' ).style.fontStyle = "italic";
		}
		if ( tempShowStars === true )
		{
			document.querySelector( '.rating-container' ).style.display = 'block';
		}
		else
		{
			document.querySelector( '.rating-container' ).style.display = 'none';
		}
	},
	
	setFancyReviewsSettings: function()
	{
		var $ = jQuery,
			tempSelect = document.getElementById( 'pickAnimation' ),
			tempAnimation = tempSelect.options[tempSelect.selectedIndex].value,
			tempBorderWidth = document.getElementById( 'borderWidth' ).value,
			tempBorderColor = document.getElementById( 'borderColor' ).value,
			tempBorderRadius = document.getElementById( 'borderRadius' ).value,
			tempBackgroundColor = document.getElementById( 'backgroundColor' ).value,
			tempShowStars = document.getElementById( 'showStars' ).checked,
			tempReviewColor = document.getElementById( 'reviewColor' ).value,
			tempReviewItalics = document.getElementById( 'italReview' ).checked,
			tempReviewerColor = document.getElementById( 'reviewerColor' ).value,
			tempReviewerItalics = document.getElementById( 'italReviewer' ).checked;
		
		var data =
		{
			action : 'setFancyReviewSettings',
			animation : tempAnimation,
			borderWidth : tempBorderWidth,
			borderColor : tempBorderColor,
			borderRadius : tempBorderRadius,
			backgroundColor : tempBackgroundColor,
			showStars : tempShowStars,
			reviewColor : tempReviewColor,
			reviewItalics : tempReviewItalics,
			reviewerColor : tempReviewerColor,
			reviewerItalics : tempReviewerItalics
			
		};
		
		var ajaxurl = '/wp-admin/admin-ajax.php';
		
		$.post( ajaxurl, data, function( response ) {
			
			$('.success').html(response).addClass('settings-box');

		});
	}
	
	
};

jQuery( function()
{
	settingsPageMain.setup();
	var $ = jQuery;
	
	$('#prev-btn').on('click', function(){
		settingsPageMain.previewFancyReviewSettings();
	});
	
	$( '#save-settings-btn' ).on( 'click', function() {
		settingsPageMain.setFancyReviewsSettings();
	});
});