<?php 

error_reporting(1); 

class ajaxController
{ 
	public function __construct()
	{ 
		$this->addActions();
		// $this->addShortcodes();
	}
	
	protected function addActions()
	{ 
		add_action( 'wp_ajax_storeReview', [ &$this, 'storeReview' ] );
		add_action( 'wp_ajax_nopriv_storeReview', [ &$this, 'storeReview' ] );
		
		add_action( 'wp_ajax_removeReview', [ &$this, 'removeReview' ] );
		add_action( 'wp_ajax_nopriv_removeReview', [ &$this, 'removeReview' ] );
		
		add_action('wp_ajax_editReview', [ &$this, 'editReview' ] );
		add_action('wp_ajax_nopriv_editReview', [ &$this, 'editReview' ] );
		
		add_action('wp_ajax_getReviews', [ &$this, 'getReviews' ] );
		add_action('wp_ajax_nopriv_getReviews', [ &$this, 'getReviews' ] );
		
		add_action('wp_ajax_fancyReviewSettings', [ &$this, 'fancyReviewSettings' ] );
		add_action('wp_ajax_nopriv_fancyReviewSettings', [ &$this, 'fancyReviewSettings' ] );
		
		add_action('wp_ajax_setFancyReviewSettings', [ &$this, 'setFancyReviewSettings' ] );
		add_action('wp_ajax_nopriv_setFancyReviewSettings', [ &$this, 'setFancyReviewSettings' ] );
		
		add_action('wp_ajax_getAllReviews', [ &$this, 'getAllReviews' ] );
		add_action('wp_ajax_nopriv_getAllReviews', [ &$this, 'getAllReviews' ] );		
	}
	
	// protected function addShortcodes()
	// {
		
	// }
	
	public function storeReview()
	{
		global $wpdb;

		$table = $wpdb->prefix . "bpi_fancy_reviews";
		$review = strip_tags( $_POST[ "review" ], '' );
		$reviewer = strip_tags( $_POST[ "reviewer" ], '' );
		$stars = strip_tags( $_POST[ "stars" ], '' );
		$should_review = strip_tags( $_POST['should_review'], '');

		$wpdb->insert( 
			$table, 
			array(
				'review'        => $review, 
				'reviewer_name' => $reviewer,
				'stars'         => $stars,
				'should_review'	=> $should_review
			)
		);

		$html = "Your review was successfully recorded. Thank you!"; 

		self::encode( $html ); 
	}
	
	public function editReview()
	{
		global $wpdb;

		$table = $wpdb->prefix . 'bpi_fancy_reviews';
		$review = strip_tags( $_POST[ 'review' ], '' );
		$reviewer = strip_tags( $_POST[ 'reviewer' ], '' );
		$stars = strip_tags( $_POST[ 'stars']. '' );
		$should_review = strip_tags($_POST['should_review'], '');
		$id = $_POST[ 'id' ];

		$wpdb->update(
			$table,
			array(	
				'reviewer_name'	=> $reviewer,
				'review'		=> $review,
				'stars'			=> $stars,
				'should_review'	=> $should_review
			),
			array(
				'id'			=> $id
			)
		);

		$html = 'Your review has been edited. Thank you!';

		self::encode( $html ); 
	}
	
	public function removeReview()
	{
		global $wpdb;

		$table = $wpdb->prefix . 'bpi_fancy_reviews';
		$remove = $_POST['id'];

		$wpdb->update( $table, array( 'show_review' => 0 ), array( 'id' => $remove ) );

		$html = 'Your review was removed. Thank you!';

		self::encode( $html ); 
	}
	
	public function fancyReviewSettings()
	{
		global $wpdb;
		$prefix = $wpdb->prefix;
		$tableName = $prefix . 'bpi_fancy_review_settings';
		
		$sql = "
			SELECT
				bpi_animation AS 'animation',
				bpi_border_width AS 'borderWidth',
				bpi_border_color AS 'borderColor',
				bpi_border_radius AS 'borderRadius',
				bpi_background_color AS 'backgroundColor',
				bpi_show_stars AS 'showStars',
				bpi_review_color AS 'reviewColor',
				bpi_review_italics AS 'reviewItalics',
				bpi_reviewer_color AS 'reviewerColor',
				bpi_reviewer_italics AS 'reviewerItalics'
			FROM
				$tableName;
		";
		
		$fancyReviewSettings = $wpdb->get_results($sql);
		
		self::encode( $fancyReviewSettings );
	}
	
	public function setFancyReviewSettings()
	{
		global $wpdb;
		$prefix = $wpdb->prefix;
		
		$tableName = $prefix . 'bpi_fancy_review_settings';
		$animation = $_POST['animation'];
		$borderWidth = $_POST['borderWidth'];
		$borderColor = $_POST['borderColor'];
		$borderRadius = $_POST['borderRadius'];
		$backgroundColor = $_POST['backgroundColor'];
		$showStars = $_POST['showStars'];
		$reviewColor = $_POST['reviewColor'];
		$reviewItalics = $_POST['reviewItalics'];
		$reviewerColor = $_POST['reviewerColor'];
		$reviewerItalics = $_POST['reviewerItalics'];
		
		
		$sql = "
			UPDATE
				$tableName
			SET
				bpi_animation = '$animation',
				bpi_border_width = '$borderWidth',
				bpi_border_color = '$borderColor',
				bpi_border_radius = '$borderRadius',
				bpi_background_color = '$backgroundColor',
				bpi_show_stars = '$showStars',
				bpi_review_color = '$reviewColor',
				bpi_review_italics = '$reviewItalics',
				bpi_reviewer_color = '$reviewerColor',
				bpi_reviewer_italics = '$reviewerItalics'
			WHERE
				id = 1;
		";
		
		$result = $wpdb->query($sql);
		
		$html = "Your review settings have been updated.";
		
		self::encode($html);
	}
	
	public function getAllReviews()
	{
		global $wpdb;
		
		$table = $wpdb->prefix . 'bpi_fancy_reviews';
		
		$sql = "SELECT reviewer_name, review, stars FROM $table WHERE show_review = 1 AND should_review = 0;";
		
		$results = $wpdb->get_results( $sql );
		
		self::encode( $results );
	}
	
	protected static function encode( $data )
	{ 
		echo json_encode($data); 
		die;
	}
}

$ajax = new ajaxController(); 

?>