<?php

$pluginName = 'BP Fancy Reviews';

class BPReviewsFunctions
{
	public $firstTableName;
	public $secondTableName;
	
	/* this will setup the form table name */ 
	function __construct() 
	{ 
		global $wpdb; 
		$prefix = $wpdb->prefix; 
		
		/* we want to use the table name by 
		getting the wpdb prefix */ 
		$this->firstTableName = $prefix . "bpi_fancy_reviews"; 
		$this->secondTableName = $prefix . "bpi_fancy_review_settings";
		
		$this->setServerTimezone(); 
	} 
	
	protected function setServerTimezone() 
	{ 
		date_default_timezone_set('America/Denver'); 
	}
	
	public function setup() 
	{ 
		
	} 
	
	public static function createFirstTable() 
	{ 
		global $wpdb; 		
		/* we need to create an instance to get the tablename */ 
		$table = new BPReviewsFunctions(); 
		$firstTableName = $table->firstTableName; 
		
		$sql = "
			CREATE TABLE IF NOT EXISTS {$firstTableName} (
				id INT NOT NULL AUTO_INCREMENT,
				reviewer_name VARCHAR(50) NOT NULL,
				review VARCHAR(500) NOT NULL,
				stars INT,
				show_review INT NOT NULL DEFAULT 1,
				INDEX (reviewer_name),
				PRIMARY KEY (id)
			) ENGINE = MYISAM;
		"; 
		
		$wpdb->query($sql); 
		$rows = $wpdb->get_results("DESCRIBE {$firstTableName}", ARRAY_A); 
		if (sizeof($rows) < 6)
		{
			$wpdb->query("ALTER TABLE {$firstTableName} ADD `should_review` INT NOT NULL DEFAULT 0");	
		} 
	}
	
	public static function createSecondTable()
	{
		global $wpdb;
		
		/* we need to create an instance to get the table name. */
		$table = new BPReviewsFunctions(); 
		$secondTableName = $table->secondTableName;
		
		$sql = "
			CREATE TABLE IF NOT EXISTS {$secondTableName} (
				id INT NOT NULL AUTO_INCREMENT,
				bpi_animation VARCHAR(50) NOT NULL,
				bpi_border_width VARCHAR(50) NOT NULL,
				bpi_border_color VARCHAR(50) NOT NULL,
				bpi_border_radius VARCHAR(50) NOT NULL,
				bpi_background_color VARCHAR(50) NOT NULL,
				bpi_show_stars VARCHAR(50) NOT NULL,
				bpi_review_color VARCHAR(50) NOT NULL,
				bpi_review_italics VARCHAR(50) NOT NULL,
				bpi_reviewer_color VARCHAR(50) NOT NULL,
				bpi_reviewer_italics VARCHAR(50) NOT NULL,
			PRIMARY KEY ( id )
			) ENGINE = MYISAM;
		";
		
		$wpdb->query($sql);
		$table->addSettings();
	}
	
	protected function addSettings()
	{
		global $wpdb;
		$table = new BPReviewsFunctions(); 
		$secondTableName = $table->secondTableName;

		$sql = "
			SELECT
				*
			FROM
				$secondTableName
		";

		$result = $wpdb->get_results($sql);

		if ($result->num_rows < 1)
		{
			$sql = "
				INSERT INTO $secondTableName
					(bpi_animation,
					 bpi_border_width,
					 bpi_border_color,
					 bpi_border_radius,
					 bpi_background_color,
					 bpi_show_stars,
					 bpi_review_color,
					 bpi_review_italics,
					 bpi_reviewer_color,
					 bpi_reviewer_italics)
				VALUES
					('curveIn',
					 '2',
					 '#000000',
					 '10',
					 'rgba(11, 43, 160, 0.7)',
					 'true',
					 '#FFFFFF',
					 'false',
					 '#FFFFFF',
					 'true');
			";
			
			$wpdb->query($sql);
		}
	}
	
	public static function destroyFirstTable()
	{
//		global $wpdb;
//
//		/* we need to create an instance to get the tablename */ 
//		$table = new BPReviewsFunctions(); 
//		$firstTableName = $table->firstTableName;
//		
//
//		$sql = "
//			DROP TABLE {$firstTableName};
//		";
//	
//		$wpdb->query($sql);
		
		
	}
	
	public static function destroySecondTable()
	{
//		global $wpdb;
//		
//		/* we need to create an instance to get the tablename */
//		$table = new BPReviewsFunctions();
//		$secondTableName = $table->secondTableName;
//		
//		$sql = "
//			DROP TABLE {$secondTableName};
//		";
//		
//		$wpdb->query($sql);
	}
}